/*
An example of how to do CS 321 HW4 problem 4
using escaped Ascii I/O.

Orion Sky Lawlor, olawlor@acm.org, 2006/04/07 (Public Domain)
*/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <math.h>
#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <string>
#include "lib/inc.h"

#include <fstream>


struct dude {
public:
	std::string name;
	std::string address;
	double karma;
	std::vector<std::string> blogs;
};

/* Make up a random string for testing */
std::string makeString(int length) {
	std::string s="";
	for (int i=0;i<length;i++) {
		if (length<20) s+='A'+(rand()%24);
		else if ((rand()&0xff)<5) s+='\n';
		else s+=32+(rand()%(127-32));
	}
	return s;
}

/* Make up some random dude objects for testing */
std::vector<dude> makeDudes(void) {
	std::vector<dude> dudes;
	int i,n=2+(rand()&3);
	for (i=0;i<n;i++) {
		dude f;
		f.name=makeString(6);
		f.address=makeString(150);
		f.karma=rand()&511;
		for (int j=0;j<(rand()&3);j++)
			f.blogs.push_back(makeString(18));
		dudes.push_back(f);
	}
	return dudes;
}
void printDude(dude &f) {
	std::cout<<"Dude:\n";
	std::cout<<"  name='"<<f.name<<"'\n";
	std::cout<<"  address='"<<f.address<<"'\n";
	std::cout<<"  kharma="<<f.karma<<"\n";
	for (unsigned int i=0;i<f.blogs.size();i++) 
		std::cout<<"  blog='"<<f.blogs[i]<<"'\n";
}
void printDudes(std::vector<dude> &dudes) {

	for (unsigned int i=0;i<dudes.size();i++) printDude(dudes[i]);
}

/* Print out this string as 'str' 
The only complicated bit is escaping
the quote and backslash characters. */
void writeString(std::ofstream &s,std::string &str) {
	s<<"'";
	for (int i=0;i<str.size();i++) {
		char c=str[i];
		if (c=='\'' || c=='\\') { /* quote or backslash--escape it */
			s<<'\\'; /* extra backslash before quotes or backslashes */
		}
		s<<c;
	}
	s<<"'\n";
}

/* Write and read all these dude objects to/from this disk file.
   You MUST write both these routines, and CANNOT change any other routine,
   (in particular, you must not change foo!)
*/
void writeDudes(const char *toFile,std::vector<dude> dudes) {
	std::ofstream s(toFile);
	s<<dudes.size()<<"\n";
	for (int i=0;i<dudes.size();i++) {
		writeString(s,dudes[i].name);
		writeString(s,dudes[i].address);
		s<<dudes[i].karma<<"\n";
		s<<dudes[i].blogs.size()<<"\n";
		for (int j=0;j<dudes[i].blogs.size();j++) 
			writeString(s,dudes[i].blogs[j]);
	}
}

void puke(const char *why) {
	std::cout<<"Puking: "<<why<<"\n";
}

void readString(std::ifstream &s,std::string &str) {
	char c;
	s>>c;
	if (c!='\'') puke("Wanted quote at start of string");
	while (1) {
		s.read(&c,1);
		if (c=='\\') { /* escape-- copy next byte *unmodified* */
			s.read(&c,1); /* don't mess with this byte (quote?) */
			str+=c;
			continue;
		}
		if (c=='\'') { /* end of string */
			return;
		}
		str+=c;
	}
	
}
void readDudes(const char *fromFile,std::vector<dude> &dudes) {
	std::ifstream s(fromFile);
	int len;
	s>>len;
	dudes.resize(len);
	for (int i=0;i<dudes.size();i++) {
		readString(s,dudes[i].name);
		readString(s,dudes[i].address);
		s>>dudes[i].karma;
		s>>len;
		dudes[i].blogs.resize(len);
		for (int j=0;j<dudes[i].blogs.size();j++) 
			readString(s,dudes[i].blogs[j]);
	}
}

int main() {
	srand(3);

/* Make up some dudes, and write them to disk */
	writeDudes("dudes.bin",makeDudes());

/* Read the dudes we just wrote */
	std::vector<dude> dudes;
	readDudes("dudes.bin",dudes);
	if (dudes.size()==0) std::cout<<"Woa--I didn't read any dudes?\n";
	printDudes(dudes);
	return 0;
}




